ParameterConstant (Media Authoring with Java API)
Date: 2016-02-05

tv.amwa.maj.constant

## Interface ParameterConstant

- All Known Implementing Classes:
    ParameterDefinitionImpl

      public interface ParameterConstant

  Implement this interface to access unique identifiers for parameters to operations, such as the video and audio effects defined by the AAF edit protocol. Additional information about each parameter appears in the parameter description that annotates each AUID constant.

  See the description of managing definitions in the package summary for more details of how to use these constants and dynamically extend the range of supported parameters.

  See Also:
    `ParameterDefinition`, `OperationDefinition`, `ParameterDescription`, `TypeDefinitions.ParameterDefinitionWeakReference`, `TypeDefinitions.ParameterDefinitionStrongReference`, `TypeDefinitions.ParameterDefinitionStrongReferenceSet`, `TypeDefinitions.ParameterDefinitionWeakReferenceSet`, `TypeDefinitions.ParameterStrongReferenceVector`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static AUID` | `AlphaKeyInvertAlpha` Used to specify whether the alpha transparency level property of the digital image descriptor associated with an alpha transparency effect should be inverted or not.
    `static AUID` | `Amplitude` Used to specify the amplitude multiplier for an mono audio gain operation.
    `static AUID` | `CropBottom` Used to specify the bottom boundary of a video crop operation.
    `static AUID` | `CropLeft` Used to specify the left-hand boundary of a video crop operation.
    `static AUID` | `CropRight` Used to specify the right-hand boundary of a video crop operation.
    `static AUID` | `CropTop` Used to specify the top boundary of a video crop operation.
    `static AUID` | `IncomingLevel` Used to specify the incoming level of a two-parameter audio dissolve operation.
    `static AUID` | `Level` Used to specify the level of mixing between input sources.
    `static AUID` | `LumKeyClip` Used to specify the luminance key clip for a luminance key operation.
    `static AUID` | `LumKeyLevel` Used to specify the luminance key level for a luminance key operation.
    `static AUID` | `OutgoingLevel` Used to specify the outgoing level of a two-parameter audio dissolve operation.
    `static AUID` | `Pan` Used to specify the pan value for a left-to-right pan position of mono audio essence on the output of a mono audio pan.
    `static AUID` | `PhaseOffset`
    `static AUID` | `PinBottomLeftX` Used to specify the horizontal component of the bottom left corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinBottomLeftY` Used to specify the vertical component of the bottom left corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinBottomRightX` Used to specify the horizontal component of the bottom right corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinBottomRightY` Used to specify the vertical component of the bottom right corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinTopLeftX` Used to specify the horizontal component of the top left corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinTopLeftY` Used to specify the vertical component of the top left corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinTopRightX` Used to specify the horizontal component of the top right corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PinTopRightY` Used to specify the vertical component of the top right corner of a quadrilateral defining a video corner pinning operation.
    `static AUID` | `PositionOffsetX` Used to specify a horizontal position offset for a video position operation.
    `static AUID` | `PositionOffsetY` Used to specify a vertical position offset for a video position operation.
    `static AUID` | `Rotation` Used to specify the angle of clockwise rotation for an image as part of a video rotate operaetion.
    `static AUID` | `ScaleX` Used to specify the horizontal scaling factor for an image as part of a video scaling operation.
    `static AUID` | `ScaleY` Used to specify the vertical scaling factor for an image as part of a video scaling operation.
    `static AUID` | `SMPTEBorder`
    `static AUID` | `SMPTECheckerboard`
    `static AUID` | `SMPTEModulator`
    `static AUID` | `SMPTEPosition`
    `static AUID` | `SMPTEReplicationH`
    `static AUID` | `SMPTEReplicationV`
    `static AUID` | `SMPTEReverse` TODO find and write a description of this
    `static AUID` | `SMPTEShadow`
    `static AUID` | `SMPTESoft`
    `static AUID` | `SMPTESpotlight`
    `static AUID` | `SMPTETumble`
    `static AUID` | `SMPTEWipeNumber` Used to specify a SMPTE Wipe Number as defined in section 7.6.33 of SMPTE 258M.
    `static AUID` | `SpeedRatio` Used to specify the ratio of output length to input length for a video speed control operation.

- - ### Field Detail

    - #### Level

          @ParameterDescription(typeName="Rational")
          static final AUID Level

      Used to specify the level of mixing between input sources. This parameter is a `Rational` and must be in the range 0 to 1.

      Parameter to operations:

      - video dissolve
      - SMPTE video wipe
      - mono audio dissolve

    - #### SMPTEWipeNumber

          @ParameterDescription(typeName="Int32")
          static final AUID SMPTEWipeNumber

      Used to specify a SMPTE Wipe Number as defined in section 7.6.33 of SMPTE 258M. This parameter is a value of `Int32` type. Note that there are many more wipe patterns defined in SMPTE&258M than are commonly used by video authoring applications.

      Parameter to operation:

      - SMPTE video wipe

    - #### SMPTEReverse

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEReverse

      TODO find and write a description of this

      This parameter is a value of boolean type.

      Parameter to operation:

      - SMPTE video wipe

    - #### SpeedRatio

          @ParameterDescription(typeName="Rational")
          static final AUID SpeedRatio

      Used to specify the ratio of output length to input length for a video speed control operation.

      This parameter is a value of `Rational` type. The range of the parameter is -231 to 231 - 1, excluding 0. For example, a value of 1/2 specifies half normal frame rate and so appears as slow motion. A value of -1/1 appears at normal frame rate played in reverse.

      Parameter to operation:

      - video speed control

    - #### PositionOffsetX

          @ParameterDescription(typeName="Rational")
          static final AUID PositionOffsetX

      Used to specify a horizontal position offset for a video position operation.

      This parameter is a value of `Rational` type. The range of the parameter is -231 to 231 - 1. A value of -1 offsets an image center to the left of the image and a value of 1 offsets the image center to the right of the image.

      Parameter to operation:

      - video position

    - #### PositionOffsetY

          @ParameterDescription(typeName="Rational")
          static final AUID PositionOffsetY

      Used to specify a vertical position offset for a video position operation.

      This parameter is a value of `Rational` type. The range of the parameter is -231 to 231 - 1. A value of -1 offsets an image center to the top of the image and a value of 1 offsets the image center to the bottom of the image.

      Parameter to operation:

      - video position

    - #### CropLeft

          @ParameterDescription(typeName="Rational")
          static final AUID CropLeft

      Used to specify the left-hand boundary of a video crop operation.

      This parameter is expressed as a fraction of the the original image coordinate space and represented by a value of `Rational` type. The range of the value is -1 to 1, where -1 is the left of the image and 1 is the right of the image.

      Parameter to operation:

      - video crop

    - #### CropRight

          @ParameterDescription(typeName="Rational")
          static final AUID CropRight

      Used to specify the right-hand boundary of a video crop operation.

      This parameter is expressed as a fraction of the the original image coordinate space and represented by a value of `Rational` type. The range of the value is -1 to 1, where -1 is the left of the image and 1 is the right of the image.

      Parameter to operation:

      - video crop

    - #### CropTop

          @ParameterDescription(typeName="Rational")
          static final AUID CropTop

      Used to specify the top boundary of a video crop operation.

      This parameter is expressed as a fraction of the the original image coordinate space and represented by a value of `Rational` type. The range of the value is -1 to 1, where -1 is the left of the image and 1 is the right of the image.

      Parameter to operation:

      - video crop

    - #### CropBottom

          @ParameterDescription(typeName="Rational")
          static final AUID CropBottom

      Used to specify the bottom boundary of a video crop operation.

      This parameter is expressed as a fraction of the the original image coordinate space and represented by a value of `Rational` type. The range of the value is -1 to 1, where -1 is the top of the image and 1 is the bottom of the image.

      Parameter to operation:

      - video crop

    - #### ScaleX

          @ParameterDescription(typeName="Rational")
          static final AUID ScaleX

      Used to specify the horizontal scaling factor for an image as part of a video scaling operation.

      This parameter is expressed as a fraction of the original image width, with the result centered about 0,0 and represented as a value of `Rational` type. The range of the value is 0 to 231 - 1, with a value of 1 representing the original size.

      Parameter to operation:

      - video scale

    - #### ScaleY

          @ParameterDescription(typeName="Rational")
          static final AUID ScaleY

      Used to specify the vertical scaling factor for an image as part of a video scaling operation.

      This parameter is expressed as a fraction of the original image height, with the result centered about 0,0 and represented as a value of `Rational` type. The range of the value is 0 to 231 - 1, with a value of 1 representing the original size.

      Parameter to operation:

      - video scale

    - #### Rotation

          @ParameterDescription(typeName="Rational")
          static final AUID Rotation

      Used to specify the angle of clockwise rotation for an image as part of a video rotate operaetion.

      This parameter is expressed as a fraction of one complete revolution, represented as a value of `Rational` type. The range of the value is 0 to 1, with 0 representing no rotation and 1 a full clockwise rotation.

      Parameter to operation:

      - video rotate

    - #### PinTopLeftX

          @ParameterDescription(typeName="Rational")
          static final AUID PinTopLeftX

      Used to specify the horizontal component of the top left corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the left of the image and 1 representing the right.

      Parameter to operation:

      - video corner pinning

    - #### PinTopLeftY

          @ParameterDescription(typeName="Rational")
          static final AUID PinTopLeftY

      Used to specify the vertical component of the top left corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the top of the image and 1 representing the bottom.

      Parameter to operation:

      - video corner pinning

    - #### PinTopRightX

          @ParameterDescription(typeName="Rational")
          static final AUID PinTopRightX

      Used to specify the horizontal component of the top right corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the left of the image and 1 representing the right.

      Parameter to operation:

      - video corner pinning

    - #### PinTopRightY

          @ParameterDescription(typeName="Rational")
          static final AUID PinTopRightY

      Used to specify the vertical component of the top right corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the top of the image and 1 representing the bottom.

      Parameter to operation:

      - video corner pinning

    - #### PinBottomLeftX

          @ParameterDescription(typeName="Rational")
          static final AUID PinBottomLeftX

      Used to specify the horizontal component of the bottom left corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the left of the image and 1 representing the right.

      Parameter to operation:

      - video corner pinning

    - #### PinBottomLeftY

          @ParameterDescription(typeName="Rational")
          static final AUID PinBottomLeftY

      Used to specify the vertical component of the bottom left corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the top of the image and 1 representing the bottom.

      Parameter to operation:

      - video corner pinning

    - #### PinBottomRightX

          @ParameterDescription(typeName="Rational")
          static final AUID PinBottomRightX

      Used to specify the horizontal component of the bottom right corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the left of the image and 1 representing the right.

      Parameter to operation:

      - video corner pinning

    - #### PinBottomRightY

          @ParameterDescription(typeName="Rational")
          static final AUID PinBottomRightY

      Used to specify the vertical component of the bottom right corner of a quadrilateral defining a video corner pinning operation.

      The parameter is expressed as a fraction of the original image size and represented as a value of `Rational` type. The range of the value is -1 to 1, with -1 representing the top of the image and 1 representing the bottom.

      Parameter to operation:

      - video corner pinning

    - #### AlphaKeyInvertAlpha

          @ParameterDescription(typeName="Boolean")
          static final AUID AlphaKeyInvertAlpha

      Used to specify whether the alpha transparency level property of the digital image descriptor associated with an alpha transparency effect should be inverted or not. This parameter is represented by a value of boolean type.

      Parameter to operation:

      - alpha with video key effect
      - separate alpha key effect

    - #### LumKeyLevel

          @ParameterDescription(typeName="Rational")
          static final AUID LumKeyLevel

      Used to specify the luminance key level for a luminance key operation. This parameter is represented by a value of Rational type in the range 0 to 231 - 1, with 0 representing black and 1 representing white.

      Parameter to operation:

      - luminance key

    - #### LumKeyClip

          @ParameterDescription(typeName="Rational")
          static final AUID LumKeyClip

      Used to specify the luminance key clip for a luminance key operation. This parameter is represented by a value of Rational type in the range 0 to 1, with 0 representing black and 1 representing white.

      Parameter to operation:

      - luminance key

    - #### Amplitude

          @ParameterDescription(typeName="Rational")
          static final AUID Amplitude

      Used to specify the amplitude multiplier for an mono audio gain operation. This parameter is represented by a value of Rational type in the range 0 to 231 - 1, with unity gain 1. This multiplier is scaled linearly.

      Parameter to operation:

      - mono audio gain

    - #### Pan

          @ParameterDescription(typeName="Rational")
          static final AUID Pan

      Used to specify the pan value for a left-to-right pan position of mono audio essence on the output of a mono audio pan. This parameter is represented by a value of `Rational` type in the range 0 to 1 with 0 representing full left, 1/2 representing half left & half right and 1 representing full right.

      Parameter to operation:

      - mono audio pan

    - #### OutgoingLevel

          @ParameterDescription(typeName="Rational")
          static final AUID OutgoingLevel

      Used to specify the outgoing level of a two-parameter audio dissolve operation. This parameter is a value of `Rational` type in the range 0 to 1. The outgoing level is scaled linearly.

      The relationship between the incoming and outgoing levels for any sample P with input samples A and B is:

      P = (IncomingLevel * B) + (OutgoingLevel * A)

      Parameter to operation:

      - two-parameter mono audio dissolve

    - #### IncomingLevel

          @ParameterDescription(typeName="Rational")
          static final AUID IncomingLevel

      Used to specify the incoming level of a two-parameter audio dissolve operation. This parameter is a value of `Rational` type in the range 0 to 1. The incoming level is scaled linearly.

      The relationship between the incoming and outgoing levels for any sample P with input samples A and B is:

      P = (IncomingLevel * B) + (OutgoingLevel * A)

      Parameter to operation:

      - two-parameter mono audio dissolve

    - #### SMPTESoft

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTESoft

    - #### SMPTEBorder

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEBorder

    - #### SMPTEPosition

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEPosition

    - #### SMPTEModulator

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEModulator

    - #### SMPTEShadow

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEShadow

    - #### SMPTETumble

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTETumble

    - #### SMPTESpotlight

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTESpotlight

    - #### SMPTEReplicationH

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEReplicationH

    - #### SMPTEReplicationV

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTEReplicationV

    - #### SMPTECheckerboard

          @ParameterDescription(typeName="Boolean")
          static final AUID SMPTECheckerboard

    - #### PhaseOffset

          @ParameterDescription(typeName="UInt32")
          static final AUID PhaseOffset

(c)2007-2016 Richard Cartwright, all rights reserved. Licensed under Apache 2 license and subject to the AMWA IPR policy.